#pragma once

#if PLATFORM_ANDROID
#include "Android/AndroidApplication.h"
#include "Android/AndroidJNI.h"
#endif

enum AirbridgeCallbackType
{
 HandleDeeplink,
 HandleDeferredDeeplink,
 Click,
 Impression,
 FetchDeviceUUID,
 FetchAirbridgeGeneratedUUID,
 CreateTrackingLink,
};

#if PLATFORM_ANDROID

/**
 * Retrieves the callback type as an integer from a Java object.
 *
 * @param Env JNI environment pointer.
 * @param This Java object for which the callback information is retrieved.
 * @return The callback type as an integer, or `-1`
 *          if `This` is `null`
 *          or if the method is not found.
 */
jint GetCallbackType(JNIEnv *Env, jobject This);

/**
 * Retrieves the callback UUID from a Java object.
 *
 * @param Env JNI environment pointer.
 * @param This Java object for which the callback information is retrieved.
 * @return The callback UUID as a `FString`, or empty string
 *          if `This` is `null`
 *          or if the method is not found
 *          or if the Java value is null.
 */
FString GetCallbackUUID(JNIEnv *Env, jobject This);

#endif