package co.ab180.airbridge.ue;

public class AirbridgeCallback {

    // The type of the callback
    private final AirbridgeCallbackType type;

    // The unique identifier (UUID) associated with the callback
    private final String uuid;

    public AirbridgeCallback(AirbridgeCallbackType type, String uuid) {
        this.type = type;
        this.uuid = uuid;
    }

    public AirbridgeCallback(AirbridgeCallbackType type) {
        this(type, null);
    }

    /**
     * Returns the callback type as an integer (ordinal value of AirbridgeCallbackType).
     *
     * @return The integer value representing the callback type (ordinal of AirbridgeCallbackType)
     */
    public int getCallbackType() {
        return type.ordinal();
    }

    /**
     * Returns the UUID associated with the callback.
     *
     * @return The UUID (String) of the callback, or null if not set
     */
    public String getUUID() {
        return uuid;
    }
}