#pragma once

#include "CoreMinimal.h"
#include "AirbridgeTrackingLink.generated.h"

/**
 * Holds variable types of tracking-link that move user
 * to specific page of app and track click-event.
 */
USTRUCT(Blueprintable)
struct FAirbridgeTrackingLink
{
	GENERATED_BODY()

	/// A tracking-link url contains short mapping-id of option.
	UPROPERTY(BlueprintReadOnly)
	FString ShortURL;

	/// A qrcode image-url of tracking-link.
	UPROPERTY(BlueprintReadOnly)
	FString QrcodeURL;
};